Compare commits

..

23 Commits
0.8 ... master

Author SHA1 Message Date
samuel c74762858b [Dev] Remove double logs in runner 2023-05-11 15:09:39 +02:00
samuel 14ed4ab071 [Dev] Display live messages in pipeline 2023-05-11 14:18:57 +02:00
samuel f9a5808607 [Fix] Do not try to install package if already upgraded just before 2023-05-11 01:59:20 +02:00
samuel e797b705ab [Dev] Add go-toolset to requirements 2023-05-11 01:58:19 +02:00
samuel 08237fc626 [Dev] Rewrite tests files to respect shellcheck and shfmt 2023-05-11 00:56:10 +02:00
samuel 8958bea96b [Fix] Replace reserved word deamon with deamonize 2023-05-10 12:59:56 +02:00
samuel e0c2fa89de [Dev] Hide ps output in runner stop 2023-05-09 15:25:55 +02:00
samuel 734bbb8ecf [Fix] Check runner sock already running only when starting 2023-05-09 15:23:43 +02:00
samuel d204aec2a6 [Dev] Hide getent output 2023-05-09 15:15:17 +02:00
samuel 5ec38ad657 [Dev] Add some logs in deployer stop 2023-05-09 15:11:59 +02:00
samuel 89131ec9ee [Fix] Fix boolean usage in deployer stop 2023-05-09 15:11:37 +02:00
samuel d5ca04a90d [Fix] Move test case to respect alphabetic order 2023-05-09 15:10:57 +02:00
samuel 40324e5be9 [Dev] Hide getent output 2023-05-09 15:09:15 +02:00
samuel c6373af98c [Dev] Add some logs in deployer stop 2023-05-09 15:02:07 +02:00
samuel 4af7c48a52 [Fix] Fix boolean command in deployer 2023-05-09 15:01:47 +02:00
samuel 048a325166 [Dev] Do not display ps output in deployer 2023-05-09 14:19:03 +02:00
samuel cde881f1b8 [Dev] Do not display getent output in deployer service 2023-05-09 14:18:47 +02:00
samuel a51c1f3d46 [Fix] Correct mistake in kill command 2023-05-07 15:34:50 +02:00
samuel 711ad6dc9e [Dev] Do not kill child jobs when stopping runner and deployer 2023-05-07 15:34:34 +02:00
samuel 8df10d8ad4 [Dev] Process each runner request in background 2023-05-04 02:20:25 +02:00
samuel 6a2617a688 [Dev] Add postional arg action in runner 2023-05-04 02:20:00 +02:00
samuel d98f5f993b [Dev] Process each deployer request in background 2023-05-04 01:27:32 +02:00
samuel e31ef119eb [Dev] Remove pid file in deployer stop 2023-05-04 01:24:37 +02:00
12 changed files with 375 additions and 280 deletions

View File

@ -86,12 +86,13 @@ install: conf/*.sample systemd/*.service bin/*
.PHONY: check_format
check_format:
shfmt --diff ./src
shfmt --diff ./src ./tests
.PHONY: check_linting
check_linting:
shfmt --find ./src | xargs bash -o noexec
shfmt --find ./src | xargs shellcheck --external-sources
shfmt --find ./src ./tests | while read f; do bash -o noexec $$f; done
shfmt --find ./src ./tests | while read f; do \
shellcheck --external-sources $$f; done
.PHONY: unit_test
unit_test:

View File

@ -1,69 +1,81 @@
# Config parsing errors.
# Deployer config parsing errors.
err_deployer_sock_empty=11
err_deployer_sock_dir_not_directory=12
err_deployer_sock_dir_not_writable=13
err_deployer_sock_already_in_use=14
err_deployer_sock_not_exist=15
err_deployer_pid_empty=16
err_deployer_pid_dir_not_directory=17
err_deployer_pid_dir_not_writable=18
err_repos_dir_empty=19
err_repos_dir_not_directory=20
err_repos_dir_not_accessible=21
err_rpms_dir_empty=22
err_rpms_dir_not_directory=23
err_rpms_dir_not_accessible=24
err_runner_username_empty=25
err_runner_user_not_exist=26
err_deployer_timeout_empty=27
err_deployer_timeout_not_valid=28
err_runner_sock_empty=29
err_runner_sock_dir_not_directory=30
err_runner_sock_dir_not_writable=31
err_runner_sock_already_in_use=32
err_runner_sock_not_exist=33
err_deployer_username_empty=34
err_deployer_user_not_exist=35
err_runner_cloning_dir_empty=36
err_runner_cloning_dir_not_directory=37
err_runner_cloning_dir_not_writable=38
err_runner_timeout_empty=39
err_runner_timeout_not_valid=40
err_git_runner_groupname_empty=41
err_git_runner_group_not_exist=42
err_runner_deployer_groupname_empty=43
err_runner_deployer_group_not_exist=44
err_pipeline_sock_dir_empty=45
err_pipeline_sock_dir_not_directory=46
err_pipeline_sock_dir_not_writable=47
err_deployer_sock_dir_not_accessible=14
err_deployer_sock_already_in_use=15
err_deployer_sock_not_exist=16
err_deployer_pid_empty=17
err_deployer_pid_dir_not_directory=18
err_deployer_pid_dir_not_writable=19
err_deployer_timeout_empty=20
err_deployer_timeout_not_valid=21
err_deployer_username_empty=22
err_deployer_user_not_exist=23
# JSON parsing errors
err_json_bad_format=51
err_pkg_name_missing=52
err_pkg_name_empty=53
err_repo_dir_not_exist=54
err_pkg_version_missing=55
err_pkg_version_empty=56
err_rpm_path_not_exist=57
err_repo_name_missing=58
err_repo_name_empty=59
err_repo_hash_missing=60
err_repo_hash_empty=61
err_repo_tag_empty=62
# Runner config parsing errors.
err_runner_username_empty=41
err_runner_user_not_exist=42
err_runner_sock_empty=43
err_runner_sock_dir_not_directory=44
err_runner_sock_dir_not_writable=45
err_runner_sock_already_in_use=46
err_runner_sock_not_exist=47
err_runner_pid_empty=48
err_runner_pid_dir_not_directory=49
err_runner_pid_dir_not_writable=50
err_runner_pid_not_exist=51
err_runner_pid_not_readable=52
err_runner_process_not_running=53
err_runner_process_not_killed=54
err_runner_cloning_dir_empty=55
err_runner_cloning_dir_not_directory=56
err_runner_cloning_dir_not_writable=57
err_runner_timeout_empty=58
err_runner_timeout_not_valid=59
err_runner_deployer_groupname_empty=60
err_runner_deployer_group_not_exist=61
err_repos_dir_empty=62
err_repos_dir_not_directory=63
err_repos_dir_not_accessible=64
err_rpms_dir_empty=65
err_rpms_dir_not_directory=66
err_rpms_dir_not_accessible=67
# Pipeline config parsing errors.
err_git_runner_groupname_empty=81
err_git_runner_group_not_exist=82
err_pipeline_sock_dir_empty=83
err_pipeline_sock_dir_not_directory=84
err_pipeline_sock_dir_not_writable=85
# JSON parsing errors.
err_json_bad_format=101
err_pkg_name_missing=102
err_pkg_name_empty=103
err_repo_dir_not_exist=104
err_pkg_version_missing=105
err_pkg_version_empty=106
err_rpm_path_not_exist=107
err_repo_name_missing=108
err_repo_name_empty=109
err_repo_hash_missing=110
err_repo_hash_empty=111
err_repo_tag_empty=112
# Operationnal errors.
err_clone_repo=101
err_checkout_hash=102
err_check_format=103
err_check_linting=104
err_unit_test=105
err_add_tag=106
err_make_tarball=107
err_rpm_build=108
err_rpm_upgrade=109
err_rpm_install=110
err_deployer_pid_not_exist=111
err_deployer_pid_not_readable=112
err_deployer_process_not_running=113
err_deployer_process_not_running=114
err_deployer_process_not_killed=115
err_clone_repo=131
err_checkout_hash=132
err_check_format=133
err_check_linting=134
err_unit_test=135
err_add_tag=136
err_make_tarball=137
err_rpm_build=138
err_rpm_upgrade=139
err_rpm_install=140
err_deployer_pid_not_exist=141
err_deployer_pid_not_readable=142
err_deployer_process_not_running=143
err_deployer_process_not_running=144
err_deployer_process_not_killed=145

View File

@ -23,6 +23,9 @@ runner_username="netoik-cicd-runner"
# Location of unixsock file used to send requests to the runner server.
runner_sock="/run/netoik-cicd/runner/runner.sock"
# Location of runner pid.
runner_pid="/run/netoik-cicd/pids/runner.pid"
# Directory in which to clone git repositories.
runner_cloning_dir="/var/tmp/netoik-cicd/repositories"

View File

@ -10,7 +10,7 @@ Source0: %{name}-%{version}.tar.gz
BuildArch: x86_64
BuildRequires: make
Requires: bash,inotify-tools,jq,nmap-ncat,rpm-build,rpmdevtools,ShellCheck,shfmt
Requires: bash,go-toolset,inotify-tools,jq,nmap-ncat,rpm-build,rpmdevtools,ShellCheck,shfmt
%description
Netoik Continuous Deployment tool
@ -63,9 +63,7 @@ systemctl daemon-reload
systemctl restart %{name}-deployer.service
systemctl enable %{name}-deployer.service
# Restart runner service.
systemctl stop %{name}-runner.service
rm --force %{_rundir}/%{name}/runner/runner.sock
systemctl start %{name}-runner.service
systemctl restart %{name}-runner.service
systemctl enable %{name}-runner.service
%preun
@ -73,7 +71,6 @@ systemctl enable %{name}-runner.service
if [ $1 -eq 0 ]; then
systemctl disable --now %{name}-deployer.service
systemctl disable --now %{name}-runner.service
rm --force %{_rundir}/%{name}/runner/runner.sock
fi
%postun

View File

@ -198,9 +198,9 @@ process_request() (
fi
log_debug "RPM path found at '${rpm_path}'."
# Upgrade package if already installed.
log_debug "Check if pkg '${pkg_name}' is already installed."
if rpm --query "${pkg_name}" 1>/dev/null 2>/dev/null; then
# Upgrade package if already installed.
log_debug "Package '${pkg_name}' already installed, so upgrade to v
${pkg_version}"
if ! output="$(sudo rpm --upgrade \
@ -210,8 +210,7 @@ process_request() (
return
fi
log_debug "RPM package '${pkg_name}' upgraded to v${pkg_version}."
fi
else
# Install package if not already installed.
log_debug "Package '${pkg_name}' is not already installed, so install
v${pkg_version}."
@ -220,6 +219,7 @@ process_request() (
"Cannot install package '${pkg_name}' v${pkg_version}: ${output}."
return
fi
fi
# Package deployed.
reply 0 "RPM package '${pkg_name}' v${pkg_version} has been deployed."
@ -231,32 +231,22 @@ process_loop() (
log_info "Start listening unixsock with keep-open at '${deployer_sock}'."
while read -r request; do
log_info "Process new request '${request}'."
process_request
process_request &
done < <(ncat --listen --keep-open --unixsock "${deployer_sock}")
log_critical "Unexpected end of listening at '${deployer_sock}'."
else
log_info "Start listening unixsock without keep-open at '${deployer_sock}'."
while read -r request; do
log_info "Process new request '${request}'."
process_request
done < <(ncat --listen --unixsock "${deployer_sock}")
log_info "End of listening at '${deployer_sock}'."
fi
# Kill all remaining subprocesses only if daemon.
log_info "End of loop."
if "${daemon}"; then
log_debug "Kill child jobs."
jobs -p | xargs kill 2>/dev/null || true
fi
# Remove sock file
log_debug "Remove deployer unixsock file."
rm --force "${deployer_sock}"
log_info "End of process."
)
main() (
# Parse arguments.
daemon="false"
daemonize="false"
keep_open="true"
config_file="${DEFAULT_CONFIG_FILE}"
errors_file="${DEFAULT_ERRORS_FILE}"
@ -278,7 +268,7 @@ main() (
shift 2
;;
-d | --daemon)
daemon="true"
daemonize="true"
shift
;;
-e | --errs)
@ -388,7 +378,7 @@ main() (
fail "Variable runner_deployer_username is empty." \
"${err_runner_deployer_groupname_empty}"
fi
if ! getent group "${runner_deployer_groupname}"; then
if ! getent group "${runner_deployer_groupname}" >/dev/null; then
fail "Runner-deployer group '${runner_deployer_groupname}' does not exist." \
"${err_runner_deployer_group_not_exist}"
fi
@ -425,7 +415,7 @@ main() (
) &
# Run process loop in background or foreground.
if "${daemon}"; then
if "${daemonize}"; then
log_info "Run process loop in background."
process_loop &
echo "$!" >"${deployer_pid}"
@ -433,7 +423,6 @@ main() (
log_info "Run process loop in foreground."
echo "$$" >"${deployer_pid}"
process_loop
jobs -p | xargs kill 2>/dev/null || true
fi
;;
stop)
@ -446,14 +435,21 @@ main() (
"${err_deployer_pid_not_readable}"
fi
pid="$(cat "${deployer_pid}")"
if ! ps -p "${pid}"; then
rm --force "${deployer_pid}"
# Kill deployer process.
log_info "Kill deployer process with pid '${pid}'."
if ! ps -p "${pid}" >/dev/null; then
fail "Deployer process with pid='${pid}' is not running." \
"${err_deployer_process_not_running}"
fi
if ! kill "${pid}" || kill --signal KILL "${pid}"; then
fail "Cannot kill deployer process." \
if ! output="$(kill "${pid}" 2>&1 || kill -KILL "${pid}" 2>&1)"; then
fail "Cannot kill deployer process: ${output}." \
"${err_deployer_process_not_killed}"
fi
# Remove deployer sock file.
log_info "Remove deployer sock at '${deployer_sock}'."
rm --force "${deployer_sock}"
;;
esac

View File

@ -259,21 +259,25 @@ main() (
echo "${runner_request}" | ncat --unixsock "${runner_sock}"
) &
# Wait for runner response.
# Start CI runner.
echo -e "Starting CI runner..."
cd "${rd_pipeline_sock_dir}"
ncat_cmd="ncat --listen --unixsock --keep-open pipeline.sock"
if [ "${runner_timeout}" -gt 0 ]; then
response="$(timeout "${runner_timeout}" ncat --listen \
--unixsock pipeline.sock)"
else
response="$(ncat --listen --unixsock pipeline.sock)"
ncat_cmd="timeout ${runner_timeout} ${ncat_cmd}"
fi
while read -r response; do
echo -e "$(echo "${response}" | jq --raw-output .msg)"
code="$(echo "${response}" | jq .code)"
[ "${code}" = "null" ] || break
done < <($ncat_cmd)
pkill --full --exact --parent "$$" "${ncat_cmd}" || true
# Remove random directory.
rm --recursive "${rd_pipeline_sock_dir}"
# Display response.
echo -e "Response from RUNNER:\n$(echo "${response}" | jq --raw-output .msg)"
exit "$(echo "${response}" | jq .code)"
exit "${code}"
)
main "$@"

View File

@ -70,7 +70,7 @@ fail() (
)
usage() (
echo "Usage: ${PROGRAM_NAME} [OPTION]...
echo "Usage: ${PROGRAM_NAME} [OPTION]... ACTION
Start runner server, wait for unixsock requests to clone git repo, run tests
and build rpm package.
@ -83,29 +83,41 @@ Mandatory argumentes for long options are mandatory for short options too.
${DEFAULT_ERRORS_FILE}
-o, --once stop listening after first request process
-q, --quiet set level verbosity to WARN, default to INFO
-t, --test just test config file and do not run start loop
-v, --verbose set level verbosity to DEBUG, default to INFO
-h, --help display this help message and exit
Positional argument ACTION
start start runner server
stop stop runner server
test tests configuration and exit
"
)
reply() (
code="$1"
msg="$2"
msg="$1"
code="$2"
if [ "${code}" -gt 0 ]; then
log_error "${msg}"
else
if [ -z "${code}" ]; then
log_info "${msg}"
json="$(jq --null-input \
--compact-output \
--arg m "${msg}" \
'{"msg":$m}')"
else
if [ "${code}" -eq 0 ]; then
log_info "${msg}"
else
log_error "${msg}"
fi
json="$(jq --null-input \
--compact-output \
--arg m "${msg}" \
--arg c "${code}" \
'{"msg":$m,"code":$c|tonumber}')"
fi
if ! output="$(jq --null-input \
--compact-output \
--arg c "${code}" \
--arg m "${msg}" \
'{"code":$c|tonumber,"msg":$m}' |
ncat --unixsock "${response_sock}" 2>&1)"; then
if ! output="$(echo "${json}" | ncat --unixsock "${response_sock}" 2>&1)"; then
log_error "Cannot write to sock '${response_sock}': ${output}."
fi
)
@ -145,17 +157,18 @@ process_request() (
log_debug "Get repo_name from json."
if ! repo_name="$(echo "${request}" |
jq --raw-output ".repo_name" 2>&1)"; then
reply "${err_json_bad_format}" \
"Cannot parse json '${request}': ${repo_name}."
reply "Cannot parse json '${request}': ${repo_name}." \
"${err_json_bad_format}"
return
fi
if [ "${repo_name}" = "null" ]; then
reply "${err_repo_name_missing}" "Missing key repo_name in '${request}'."
reply "Missing key repo_name in '${request}'." \
"${err_repo_name_missing}"
return
fi
if [ -z "${repo_name}" ]; then
reply "${err_repo_name_empty}" \
"Empty value for key repo_name in '${request}'."
reply "Empty value for key repo_name in '${request}'." \
"${err_repo_name_empty}"
return
fi
log_debug "Got pkg name: '${repo_name}'."
@ -163,7 +176,8 @@ process_request() (
# Get repository folder.
repo_dir="${repos_dir}/${repo_name}.git"
if [ ! -d "${repo_dir}" ]; then
reply "${err_repo_dir_not_exist}" "Repository '${repo_dir}' does not exist."
reply "Repository '${repo_dir}' does not exist." \
"${err_repo_dir_not_exist}"
return
fi
log_debug "Repository is present at '${repo_dir}'."
@ -171,30 +185,31 @@ process_request() (
# Get repo_hash from json.
log_debug "Get repo_hash from json."
if ! repo_hash=$(echo "${request}" | jq --raw-output ".repo_hash" 2>&1); then
reply "${err_json_bad_format}" \
"Cannot parse json '${request}': ${repo_hash}."
reply "Cannot parse json '${request}': ${repo_hash}." \
"${err_json_bad_format}"
return
fi
if [ "${repo_hash}" = "null" ]; then
reply "${err_repo_hash_missing}" "Missing key repo_hash in '${request}'."
reply "Missing key repo_hash in '${request}'." \
"${err_repo_hash_missing}"
return
fi
if [ -z "${repo_hash}" ]; then
reply "${err_repo_hash_empty}" \
"Empty value for key repo_hash in '${request}'." 1>&2
reply "Empty value for key repo_hash in '${request}'." \
"${err_repo_hash_empty}"
return
fi
# Get repo_tag from json.
log_debug "Get repo_tag from json."
if ! repo_tag=$(echo "${request}" | jq --raw-output ".repo_tag"); then
reply "${err_json_bad_format}" \
"Cannot parse json '${request}': ${repo_tag}."
reply "Cannot parse json '${request}': ${repo_tag}." \
"${err_json_bad_format}"
return
fi
if [ -z "${repo_tag}" ]; then
reply "${err_repo_tag_empty}" \
"Empty value for key repo_tag in '${request}'."
reply "Empty value for key repo_tag in '${request}'." \
"${err_repo_tag_empty}"
return
fi
@ -203,66 +218,72 @@ process_request() (
[ "${repo_tag}" != "null" ] && repo_id="${repo_tag}"
rand="$(echo "${RANDOM}" | md5sum | head --bytes 7)"
repo_clone="${runner_cloning_dir}/${repo_name}-${repo_id}-${rand}"
log_info "Clone '$repo_name'."
if ! output="$(git clone "$repo_dir" "$repo_clone" 2>&1)"; then
reply "${err_clone_repo}" "Cannot clone repo '${repo_name}': ${output}."
reply "Cloning repo '${repo_name}'..."
if ! output="$(git clone "${repo_dir}" "${repo_clone}" 2>&1)"; then
reply "Cannot clone repo '${repo_name}': ${output}." \
"${err_clone_repo}"
return
fi
cd "$repo_clone"
# Checkout git hash.
log_info "Checkout hash $repo_hash."
reply "Checkouting hash '${repo_hash}..."
if ! output="$(git checkout "$repo_hash" 2>&1)"; then
reply "${err_checkout_hash}" \
"Cannot checkout hash '${repo_hash}': ${output}."
reply "Cannot checkout hash '${repo_hash}': ${output}." \
"${err_checkout_hash}"
return
fi
# Check code validity.
log_info "Check code validity."
reply "Checking code format..."
if ! output="$(make check_format 2>&1)"; then
reply "${err_check_format}" "Check format error: ${output}."
reply "Check format error: ${output}." "${err_check_format}"
return
fi
reply "Checking code linting..."
if ! output="$(make check_linting 2>&1)"; then
reply "${err_check_linting}" "Check linting error: ${output}."
reply "Check linting error: ${output}." "${err_check_linting}"
return
fi
reply "Running unit tests..."
if ! output="$(make unit_test 2>&1)"; then
reply "${err_unit_test}" "Unit test error: ${output}."
reply "Unit test error: ${output}." "${err_unit_test}"
return
fi
# Stop now if no tag specified.
if [ "$repo_tag" = "null" ]; then
reply 0 "Hash '${repo_hash}' OK for repo '${repo_name}'."
reply "Hash '${repo_hash}' OK for repo '${repo_name}'." 0
return
fi
# Build rpm package.
echo "Build RPM package."
reply "Adding tag '${repo_tag}'..."
if ! output="$(git tag --message="$repo_tag" "$repo_tag" 2>&1)"; then
reply "${err_add_tag}" "Cannot add git tag '${repo_tag}': ${output}."
reply "Cannot add git tag '${repo_tag}': ${output}." "${err_add_tag}"
return
fi
reply "Making source tarball..."
if ! output="$(make tarball 2>&1)"; then
reply "${err_make_tarball}" \
"Cannot make tarball for tag '${repo_tag}': ${output}."
reply "Cannot make tarball for tag '${repo_tag}': ${output}." \
"${err_make_tarball}"
return
fi
repo_version="$(make version)"
reply "Building RPM package '${repo_name}' v${repo_version}..."
if ! output="$(rpmbuild -bb "$repo_name.spec" 2>&1)"; then
reply "${err_rpm_build}" \
"Cannot build rpm for tag '${repo_tag}': ${output}."
reply "Cannot build rpm for tag '${repo_tag}': ${output}." \
"${err_rpm_build}"
return
fi
# Deploy rpm package.
log_info "Deploy RPM package."
reply "Deploying RPM package '${repo_name}' v${repo_version}..."
deployer_request="$(jq --null-input \
--compact-output \
--arg s "${repo_clone}/runner.sock" \
--arg n "${repo_name}" \
--arg v "$(make version)" \
--arg v "${repo_version}" \
'{"response_sock":$s,"pkg_name":$n,"pkg_version":$v}')"
(
inotifywait --timeout 1 --quiet --quiet \
@ -287,41 +308,30 @@ process_loop() (
log_info "Start listening unixsock with keep-open at '${runner_sock}'."
while read -r request; do
log_info "Process new request '${request}'."
process_request
process_request &
done < <(ncat --listen --keep-open --unixsock "${runner_sock}")
log_critical "Unexpected end of listening at '${deployer_sock}'."
else
log_info "Start listening unixsock without keep-open at '${runner_sock}'."
while read -r request; do
log_info "Process new request '${request}'."
process_request
done < <(ncat --listen --unixsock "${runner_sock}")
log_info "End of listening at '${deployer_sock}'."
fi
# Kill all remaining subprocesses only if daemon.
log_info "End of loop."
if "${daemonize}"; then
log_debug "Kill child jobs."
jobs -p | xargs kill 2>/dev/null || true
fi
# Remove sock file.
log_debug "Remove deployer unixsock file."
rm --force "${runner_sock}"
log_info "End of process."
)
main() (
# Parse arguments.
daemonize="false"
testing="false"
keep_open="true"
config_file="${DEFAULT_CONFIG_FILE}"
errors_file="${DEFAULT_ERRORS_FILE}"
verbosity_option=""
verbosity_level="${DEFAULT_VERBOSITY_LEVEL}"
if ! args="$(getopt --name "${PROGRAM_NAME}" \
--options c:de:hoqtv \
--longoptions conf:,daemon,errs:,help,once,quiet,test,verbose \
--options c:de:hoqv \
--longoptions conf:,daemon,errs:,help,once,quiet,verbose \
-- "$@")"; then
usage
fail "Bad arguments."
@ -359,10 +369,6 @@ main() (
((verbosity_level -= 10))
shift
;;
-t | --test)
testing="true"
shift
;;
-v | --verbose)
if [ "${verbosity_option}" ]; then
usage
@ -382,10 +388,19 @@ main() (
;;
esac
done
if [ "$@" ]; then
if [ $# -ne 1 ]; then
usage
fail "Unexpected extra arguments '$*'."
fail "Missing positional argument ACTION."
fi
case "$1" in
start | stop | test)
action="$1"
;;
*)
usage
fail "Bad postional argument ACTION '$1'."
;;
esac
# Load config file.
if [ ! -r "${config_file}" ]; then
@ -407,9 +422,13 @@ main() (
if [ -z "${deployer_sock}" ]; then
fail "Variable deployer_sock is empty." "${err_deployer_sock_empty}"
fi
if [ ! -S "${deployer_sock}" ]; then
fail "Sock deployer_sock='${deployer_sock}' does not exist." \
"${err_deployer_sock_not_exist}"
if [ ! -d "$(dirname "${deployer_sock}")" ]; then
fail "Dirname of deployer_sock='${deployer_sock}' is not a directory." \
"${err_deployer_sock_dir_not_directory}"
fi
if [ ! -x "$(dirname "${deployer_sock}")" ]; then
fail "Dirname of deployer_sock='${deployer_sock}' is not accessible." \
"${err_deployer_sock_dir_not_accessible}"
fi
if [ -z "${deployer_timeout}" ]; then
@ -431,10 +450,6 @@ main() (
fail "Directory of runner_sock='${runner_sock}' is not writable." \
"${err_runner_sock_dir_not_writable}"
fi
if [ -e "${runner_sock}" ]; then
fail "Sock deployer_sock='${runner_sock}' is already in use." \
"${err_runner_sock_already_in_use}"
fi
if [ -z "${runner_cloning_dir}" ]; then
fail "Variable runner_cloning_dir is empty." \
@ -472,7 +487,7 @@ main() (
if [ -z "${runner_deployer_groupname}" ]; then
fail "Variable runner_deployer_groupname is empty." "${err_runner_deployer_groupname_empty}"
fi
if ! getent group "${runner_deployer_groupname}"; then
if ! getent group "${runner_deployer_groupname}" >/dev/null; then
fail "Runner-deployer group '${runner_deployer_groupname}' does not exist." \
"${err_runner_deployer_group_not_exist}"
fi
@ -480,14 +495,38 @@ main() (
if [ -z "${git_runner_groupname}" ]; then
fail "Variable git_runner_groupname is empty." "${err_git_runner_groupname_empty}"
fi
if ! getent group "${git_runner_groupname}"; then
if ! getent group "${git_runner_groupname}" >/dev/null; then
fail "Git-runner group '${git_runner_groupname}' does not exist." \
"${err_git_runner_group_not_exist}"
fi
# Stop now if we are only testing config.
if "${testing}"; then
if [ -z "${runner_pid}" ]; then
fail "Variable runner_pid is empty." "${err_runner_pid_empty}"
fi
if [ ! -d "$(dirname "${runner_pid}")" ]; then
fail "Dirname of runner_pid='${runner_pid}' is not a directory." \
"${err_runner_pid_dir_not_directory}"
fi
if [ ! -w "$(dirname "${runner_pid}")" ]; then
fail "Dirname of runner_pid='${runner_pid}' is not writable." \
"${err_runner_pid_dir_not_writable}"
fi
# Run chosen action.
case "${action}" in
test)
# Stop now if we are only testing.
log_info "Configuration OK."
exit 0
;;
start)
if [ ! -S "${deployer_sock}" ]; then
fail "Sock deployer_sock='${deployer_sock}' does not exist." \
"${err_deployer_sock_not_exist}"
fi
if [ -e "${runner_sock}" ]; then
fail "Sock deployer_sock='${runner_sock}' is already in use." \
"${err_runner_sock_already_in_use}"
fi
# Set right access in background after nc listen.
@ -502,11 +541,41 @@ main() (
if "${daemonize}"; then
log_info "Run process loop in background."
process_loop &
echo "$!" >"${runner_pid}"
else
log_info "Run process loop in foreground."
echo "$$" >"${runner_pid}"
process_loop
jobs -p | xargs kill 2>/dev/null || true
fi
;;
stop)
if [ ! -f "${runner_pid}" ]; then
fail "File runner_pid='${runner_pid}' does not exist." \
"${err_runner_pid_not_exist}"
fi
if [ ! -r "${runner_pid}" ]; then
fail "File runner_pid='${runner_pid}' is not readable." \
"${err_runner_pid_not_readable}"
fi
pid="$(cat "${runner_pid}")"
rm --force "${runner_pid}"
# Kill runner process.
log_info "Kill runner process with pid '${pid}'."
if ! ps -p "${pid}" >/dev/null; then
fail "Runner process with pid='${pid}' is not running." \
"${err_runner_process_not_running}"
fi
if ! output="$(kill "${pid}" || kill -KILL "${pid}")"; then
fail "Cannot kill runner process: ${output}." \
"${err_runner_process_not_killed}"
fi
# Remove runner sock file.
log_info "Remove runner sock at '${runner_sock}'."
rm --force "${runner_sock}"
;;
esac
)
main "$@"

View File

@ -5,7 +5,8 @@ After=network.target netoik-cicd-deployer.service
[Service]
User=netoik-cicd-runner
Group=netoik-cicd-runner-deployer
ExecStart=/usr/bin/netoik-cicd-runner
ExecStart=/usr/bin/netoik-cicd-runner start
ExecStop=/usr/bin/netoik-cicd-runner stop
Restart=always
[Install]

View File

@ -5,6 +5,7 @@
bats_require_minimum_version 1.5.0
setup() {
# shellcheck source=./tests/tests.conf
source "${PWD}/tests/tests.conf"
make build >/dev/null
DESTDIR="${temp}" make install >/dev/null
@ -13,6 +14,7 @@ setup() {
"${temp}${sysconf_dir}/${name}/${name}.conf"
install --directory "${temp}${var_dir}/${name}/repositories/test.git"
install --directory "${temp}${var_dir}/${name}/RPMS"
# shellcheck source=./conf/errors.conf.sample
source "${errs_file}"
}
@ -21,7 +23,7 @@ teardown() {
make clean >/dev/null
}
@test "run with bad arguments" {
run_with_bad_arguments() { #@test
run -1 "${deployer_bin}" -z test
run -1 "${deployer_bin}" --zzz test
run -1 "${deployer_bin}" zzz
@ -35,7 +37,7 @@ teardown() {
run -1 "${deployer_bin}" --verbose --quiet test
}
@test "run without loop" {
run_without_loop() { #@test
"${deployer_bin}" --conf="${conf_file}" --errs="${errs_file}" --verbose test
}
@ -54,56 +56,56 @@ send_request() (
return "${code}"
)
@test "run with err_pkg_name_missing" {
run_with_err_pkg_name_missing() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_pkg_name_missing}"
echo "status: got ${status:?}, expected ${err_pkg_name_missing}"
[ "${status}" -eq "${err_pkg_name_missing}" ]
}
@test "run with err_pkg_name_empty" {
run_with_err_pkg_name_empty() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"pkg_name":""}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_pkg_name_empty}"
echo "status: got ${status:?}, expected ${err_pkg_name_empty}"
[ "${status}" -eq "${err_pkg_name_empty}" ]
}
@test "run with err_repo_dir_not_exist" {
run_with_err_repo_dir_not_exist() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"pkg_name":"not_exist"}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_dir_not_exist}"
echo "status: got ${status:?}, expected ${err_repo_dir_not_exist}"
[ "${status}" -eq "${err_repo_dir_not_exist}" ]
}
@test "run with err_pkg_version_missing" {
run_with_err_pkg_version_missing() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"pkg_name":"test"}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_pkg_version_missing}"
echo "status: got ${status:?}, expected ${err_pkg_version_missing}"
[ "${status}" -eq "${err_pkg_version_missing}" ]
}
@test "run with err_pkg_version_empty" {
run_with_err_pkg_version_empty() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"pkg_name":"test","pkg_version":""}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_pkg_version_empty}"
echo "status: got ${status:?}, expected ${err_pkg_version_empty}"
[ "${status}" -eq "${err_pkg_version_empty}" ]
}
@test "run with err_rpm_path_not_exist" {
run_with_err_rpm_path_not_exist() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"pkg_name":"test","pkg_version":"0.1"}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_rpm_path_not_exist}"
echo "status: got ${status:?}, expected ${err_rpm_path_not_exist}"
[ "${status}" -eq "${err_rpm_path_not_exist}" ]
}

View File

@ -5,12 +5,14 @@
bats_require_minimum_version 1.5.0
setup() {
# shellcheck source=./tests/tests.conf
source "${PWD}/tests/tests.conf"
make build >/dev/null
DESTDIR="${temp}" make install >/dev/null
install --no-target-directory \
"${PWD}/tests/tests.conf" \
"${temp}${sysconf_dir}/${name}/${name}.conf"
# shellcheck source=./conf/errors.conf.sample
source "${errs_file}"
}
@ -19,7 +21,7 @@ teardown() {
make clean >/dev/null
}
@test "run with bad arguments" {
run_with_bad_arguments() { #@test
run -1 "${pipeline_bin}"
run -1 "${pipeline_bin}" bad_pipeline
@ -39,21 +41,21 @@ teardown() {
run -1 "${pipeline_bin}" -e /path/to/nowhere -H hash -n name newcommit
}
@test "run without runner sock" {
run_without_runner_sock() { #@test
run "${pipeline_bin}" --conf="${conf_file}" --errs="${errs_file}" \
--test --hash hash --name name newcommit
echo "status: got ${status}, expected ${err_runner_sock_not_exist}"
echo "status: got ${status:?}, expected ${err_runner_sock_not_exist}"
[ "${status}" -eq "${err_runner_sock_not_exist}" ]
}
@test "run newcommit ok" {
run_newcommit_ok() { #@test
ncat --listen --unixsock "${runner_sock}" &
"${pipeline_bin}" --conf="${conf_file}" --errs="${errs_file}" \
--test --hash hash --name name newcommit
echo "done" | ncat --unixsock "${runner_sock}"
}
@test "run newtag ok" {
run_newtag_ok() { #@test
ncat --listen --unixsock "${runner_sock}" &
"${pipeline_bin}" --conf="${conf_file}" --errs="${errs_file}" \
--test --hash hash --name name --tag tag newtag

View File

@ -5,6 +5,7 @@
bats_require_minimum_version 1.5.0
setup() {
# shellcheck source=./tests/tests.conf
source "${PWD}/tests/tests.conf"
make build >/dev/null
DESTDIR="${temp}" make install >/dev/null
@ -13,6 +14,7 @@ setup() {
"${temp}${sysconf_dir}/${name}/${name}.conf"
install --directory "${temp}${var_dir}/${name}/repositories/test.git"
install --directory "${temp}${var_dir}/${name}/RPMS"
# shellcheck source=./conf/errors.conf.sample
source "${errs_file}"
}
@ -21,7 +23,7 @@ teardown() {
make clean >/dev/null
}
@test "run with bad arguments" {
run_with_bad_arguments() { #@test
run -1 "${runner_bin}" -z
run -1 "${runner_bin}" --zzz
run -1 "${runner_bin}" zzz
@ -35,9 +37,9 @@ teardown() {
run -1 "${runner_bin}" --verbose --quiet
}
@test "run without loop" {
run_without_loop() { #@test
ncat --listen --unixsock "${deployer_sock}" &
"${runner_bin}" --conf="${conf_file}" --errs="${errs_file}" --test --verbose
"${runner_bin}" --conf="${conf_file}" --errs="${errs_file}" --verbose test
echo "done" | ncat --unixsock "${deployer_sock}"
}
@ -46,10 +48,11 @@ send_request() (
ncat --listen --unixsock "${deployer_sock}" &
"${runner_bin}" --conf="${conf_file}" --errs="${errs_file}" \
--daemon --once --verbose
--daemon --once --verbose start
code=$?
if [ "${code}" -ne 0 ]; then
echo "fail" | ncat --unixsock "${deployer_sock}"
"${runner_bin}" --conf="${conf_file}" --errs="${errs_file}" stop
return "${code}"
fi
(
@ -58,59 +61,61 @@ send_request() (
echo "${request}" | ncat --unixsock "${runner_sock}"
) &
echo "done" | ncat --unixsock "${deployer_sock}"
return "$(ncat --listen --unixsock "${response_sock}" | jq .code)"
code="$(ncat --listen --unixsock "${response_sock}" | jq .code)"
"${runner_bin}" --conf="${conf_file}" --errs="${errs_file}" stop
return "${code}"
)
@test "run with err_repo_name_missing" {
run_with_err_repo_name_missing() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_name_missing}"
echo "status: got ${status:?}, expected ${err_repo_name_missing}"
[ "${status}" -eq "${err_repo_name_missing}" ]
}
@test "run with err_repo_name_empty" {
run_with_err_repo_name_empty() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"repo_name":""}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_name_empty}"
echo "status: got ${status:?}, expected ${err_repo_name_empty}"
[ "${status}" -eq "${err_repo_name_empty}" ]
}
@test "run with err_repo_dir_not_exist" {
run_with_err_repo_dir_not_exist() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"repo_name":"not_exist"}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_dir_not_exist}"
echo "status: got ${status:?}, expected ${err_repo_dir_not_exist}"
[ "${status}" -eq "${err_repo_dir_not_exist}" ]
}
@test "run with err_repo_hash_missing" {
run_with_err_repo_hash_missing() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"repo_name":"test"}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_hash_missing}"
echo "status: got ${status:?}, expected ${err_repo_hash_missing}"
[ "${status}" -eq "${err_repo_hash_missing}" ]
}
@test "run with err_repo_hash_empty" {
run_with_err_repo_hash_empty() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"repo_name":"test","repo_hash":""}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_hash_empty}"
echo "status: got ${status:?}, expected ${err_repo_hash_empty}"
[ "${status}" -eq "${err_repo_hash_empty}" ]
}
@test "run with err_repo_tag_empty" {
run_with_err_repo_tag_empty() { #@test
request="$(jq --null-input --compact-output \
--arg s "${response_sock}" \
'{"response_sock":$s,"repo_name":"test","repo_hash":"hash","repo_tag":""}')"
run send_request "${request}"
echo "status: got ${status}, expected ${err_repo_tag_empty}"
echo "status: got ${status:?}, expected ${err_repo_tag_empty}"
[ "${status}" -eq "${err_repo_tag_empty}" ]
}

View File

@ -38,6 +38,9 @@ runner_username="$(id --user --name)"
# Location of unixsock file used to send requests to the runner server.
runner_sock="${temp}${run_dir}/${name}/runner/runner.sock"
# Location of deployer pid.
runner_pid="${temp}${run_dir}/${name}/pids/runner.pid"
# Directory in which to clone git repositories.
runner_cloning_dir="${temp}${tmp_dir}/${name}/repositories"